#pragma once
#include "CommandShm.hpp"

#include <boost/thread.hpp>

#include <memory>
#include <atomic>

class ShmServer {

	public:
		ShmServer();
		~ShmServer() noexcept;
		void start();
		void stop() noexcept;

	private:
		// this loops over the shm command buffer 
		void command_thread() noexcept;

		std::unique_ptr<boost::thread>  m_command_thread; //!< listen on shared memory for commands
		std::atomic<bool>               m_interrupted;    //!< boost threads interrupt doesn't work on interprocess condition's wait()
		CommandInterfaceSPtr            m_command_memory; //!< we interact with a client (!) singular for now this way.
};
